//============================================================================
// CDirectoryItem.h		1997 Metrowerks Inc. All rights reserved
// Original author: John C. Daub
//============================================================================
// A concrete LOutlineItem for items of type "directory".

#pragma once

#include <LOutlineItem.h>

class CFileItem;

class CDirectoryItem : public LOutlineItem
{

public:

		OSType				fSelector;
		Uint32				fSubValues;
		long				fNameId;
		bool				fState;

								CDirectoryItem( int nameId, OSType selector, Uint32 subValues );
		virtual					~CDirectoryItem();
		

		virtual Boolean			CanExpand() const;

protected:

		void SetState(bool state);

		virtual void			GetDrawContentsSelf(
									const STableCell&		inCell,
									SOutlineDrawContents&	ioDrawContents);

		virtual void			DrawRowAdornments(
									const Rect&				inLocalRowRect);
		
		virtual	void			ExpandSelf();


		virtual void			DoubleClick(
									const STableCell&			inCell,
									const SMouseDownEvent&		inMouseDown,
									const SOutlineDrawContents&	inDrawContents,
									Boolean						inHitText);
				
	virtual void			TrackContentClick(
									const STableCell&			inCell,
									const SMouseDownEvent&		inMouseDown,
									const SOutlineDrawContents&	inDrawContents,
									Boolean						inHitText);
private:

								CDirectoryItem();
								CDirectoryItem( const CDirectoryItem &inOriginal );
			CDirectoryItem&		operator=( const CDirectoryItem &inOriginal );
};