//============================================================================
// CFileItem.h		1997 Metrowerks Inc. All rights reserved
// Original author: John C. Daub
//============================================================================
// A concrete LOutlineItem for items of type "file"

#pragma once

#include <LOutlineItem.h>
#include <LString.h>

class CFileItem : public LOutlineItem
{

public:

		int						fNameId;
		OSType					fSelector;
		int						fBit;
		bool					fState;

								CFileItem(
									int		nameId,
									OSType	selector,
									int		bit
								);

		virtual					~CFileItem();
		

protected:
		
		void SetState(bool state);

		virtual void			GetDrawContentsSelf(
									const STableCell&		inCell,
									SOutlineDrawContents&	ioDrawContents);

		virtual void			DrawRowAdornments(
									const Rect&				inLocalRowRect);
		

		virtual void			DoubleClick(
									const STableCell&			inCell,
									const SMouseDownEvent&		inMouseDown,
									const SOutlineDrawContents&	inDrawContents,
									Boolean						inHitText);

	virtual void			TrackContentClick(
									const STableCell&			inCell,
									const SMouseDownEvent&		inMouseDown,
									const SOutlineDrawContents&	inDrawContents,
									Boolean						inHitText);

private:

			// defensive programming
			
								CFileItem();
								CFileItem( const CFileItem &inOriginal );
					CFileItem&	operator=( const CFileItem &inOriginal );

};