// Program Author: Paul Baxter
//	pbaxter@assistivetech.com
//
//

typedef ResType CommandType;

#define kCommandMask	0xFFFFFF00
#define kValueMask		0x000000FF
#define kValueShift		24

typedef void (*ActionProcPtr)(CommandType command, void* refCon);

typedef struct {
	CommandType command;
	ActionProcPtr action;
} CommandEntry;


#define VoiceCmd				'VOI '
#define SpeakCharsCmd			'SPC '
#define SpeakWordsCmd			'SWD '
#define SpeakSentencesCmd		'SPS '
#define QuitCmd					'QUI '
#define AboutCmd				'ABO '
#define OpenDescAccCmd			'ODC '

#define kToggleValue			'!'
#define kIncValue				'+'
#define kDecValue				'-'
#define kSetValMin				'0'
#define kSetValMax				'9'
#define kStringValue			'%'
#define kTrueValue				(true + kSetValMin)
#define kFalseValue				(false + kSetValMin)


#define CHANGEVALUE(cmd, val)	(cmd & kCommandMask) | (val & kValueMask)
#define TOGGLE_COMMAND(cmd)		CHANGEVALUE(cmd, kToggleValue)
#define STRING_COMMAND(cmd)		CHANGEVALUE(cmd, kStringValue)

extern void ProcessCommand(CommandType command, void* param);
