program crash;

uses
	Memory,
	QuickDraw,
	Fonts,
	Windows,
	TextEdit,
	Dialogs,
	GestaltEqu,
	Appearance,
	globals,
	Processes,
	misc,
	ae,
	main,
	cwindow,
	preferences;
	
var
	gestaltError:OSErr;
	gestaltResponse:longint;
	err:OSErr;
	
procedure FatalAlert(cause:integer);
var
	dummy:integer;
	errorText:Str255;
begin
	errorText:=GetResString(FATAL_ALERT_TEXT_ID,cause);
	ParamText(errorText,'','','');
	dummy:=Alert(FATAL_ALERT_ID,nil);
	ExitToShell;
end;

procedure DrawMenus;
var
	myMenuBar:Handle;
begin
	myMenuBar:=GetNewMBar(MENU_BAR_ID);
	SetMenuBar(myMenuBar);
	DisposeHandle(myMenuBar);
	gAppleMenuH:=GetMenuHandle(APPLE_MENU);
	gFileMenuH:=GetMenuHandle(FILE_MENU);
	gEditMenuH:=GetMenuHandle(EDIT_MENU);
	AppendResMenu(gAppleMenuH,'DRVR');
	DrawMenuBar;
end;

begin

{ Basic Toolbox initialization }
	MaxApplZone;
	InitGraf(@qd.thePort);
	InitFonts;
	InitWindows;
	InitMenus;
	TEInit;
	InitDialogs(nil);
	InitCursor;

{ Check for Appearance Manager }
	gestaltError:=Gestalt(gestaltAppearanceAttr,gestaltResponse);
	if (gestaltError=noErr) then begin
		if (not BTST(gestaltResponse,gestaltAppearanceExists)) then begin
			FatalAlert(NEED_APPEARANCE);
		end;
	end else begin
		FatalAlert(NEED_APPEARANCE);
	end;
	
{ Initialize globals }
	InitGlobals;
	
{ Install Apple Event Handlers }
	InstallAppleEventHandlers;
	
{ Register with the Appearance Manager }
	err:=RegisterAppearanceClient;
	
	LoadPreferences(@gThePrefs,sizeof(gThePrefs),'Crash Manager Prefs');
	
	DrawMenus;
	DisplayWindow;
	
	DoMainLoop;
	
	RemoveWindow;
	
	SavePreferences(@gThePrefs,sizeof(gThePrefs),'Crash Manager Prefs');
	
{ Unregister with the Appearance Manager }
	err:=UnregisterAppearanceClient;
	
{ Remove Apple Event Handlers }
	RemoveAppleEventHandlers;
	
end.
