Export USE_MR_PLUS

Set DEBUG		 		 1
Set USE_TRACEBACKS 		 1
Set USE_MR_PLUS 		 0
Set OPTIMIZE             0

###.............................................................................

#This gives a path to the root of my source tree. 
Set SRC_ROOT "Moonlighting:TVSource:"

#This gives a path to the MacOS headers. It is used to derive paths to 
# the standard (public) headers, and the various private headers.
Set MW_ROOT "Moonlighting:Commercial Apps:Metrowerks:Metrowerks CodeWarrior:"

#This directory stores temp files and can be trashed when we're done.
Set TEMP_ROOT "{SRC_ROOT}Temp:"

#This gives the path of the directory you want the result to appear in.
Set OUTPUT_ROOT "{SRC_ROOT}Output:"

Set MW_ROOT_HEADERS "{MW_ROOT}MacOS Support:Headers:"
Set MW_ROOT_LIBS 	"{MW_ROOT}MacOS Support:Libraries:"

Export SRC_ROOT
Export TEMP_ROOT
Export OUTPUT_ROOT

###.............................................................................

#Source file paths.

Set CODE_ROOT				"{SRC_ROOT}SourceThatMatters:"
Set GENERAL_ROOT 			"{CODE_ROOT}General:"
Set IMPORT_ROOT  			"{CODE_ROOT}Import:"
Set MEDIA_ROOT   			"{CODE_ROOT}Media:"

Export CODE_ROOT
Export GENERAL_ROOT
Export IMPORT_ROOT
Export MEDIA_ROOT

###.............................................................................

#Headers.

Set Rincludes "{MW_ROOT_HEADERS}Rez Headers:"

Set CINCLUDES		
  "{MW_ROOT_HEADERS}Universal Headers:"
Set ANSI_INCLUDES	
  "{MW_ROOT}Metrowerks Standard Library:MSL C:MSL Common:Public Includes:"

Set H_DIRS "														
  -i "{IMPORT_ROOT}"  											
  -i "{MEDIA_ROOT}" 												
  -i "{GENERAL_ROOT}" -i "{CODE_ROOT}" 							
  -i "{CINCLUDES}" 												
  -i "{ANSI_INCLUDES}" "

Export H_DIRS

###.............................................................................

#Libraries we need to link against.

Set DEBUG_LIB_PATH				"{SRC_ROOT}Libraries:mjhDebugLib"
Set QT_LIB_PATH		        	"{MW_ROOT_LIBS}QT Libs:QuickTimeLib"
Set COMPONENTS_LIB_PATH 		"{MW_ROOT_LIBS}QT Libs:ComponentsInterfacesLib"
Set INTERFACE_LIB_PATH		 	"{MW_ROOT_LIBS}MacOS Common:InterfaceLib"
Set MATH_LIB_PATH				"{MW_ROOT_LIBS}MacOS Common:MathLib"

Set	LIBRARIES "													
	"{DEBUG_LIB_PATH}"										
	"{RUNTIME_LIB_PATH}"										
	"{QT_LIB_PATH}"											
	"{COMPONENTS_LIB_PATH}"									
	"{INTERFACE_LIB_PATH}"									
	"{MATH_LIB_PATH}"	"



Export LIBRARIES

###=============================================================================

#The define below tells our source code that the component is being built 
# stand-alone (as opposed to part of an app).
#The -opt speed, unroll are optimization parameters.
#The -w17 says to suppress warnings about unrecognized #pragmas.
#The -traceback inserts MacsBug symbols.

Set DEFINES " 									
  -d _NEW_UNIV_IFC_=1  -d TARGET_OS_MAC=1 		
  -d STAND_ALONE=1 								
  -d DEBUG={DEBUG} "

Set C_OPTIONS "{DEFINES} -w 17 --be -Xalias"
If {OPTIMIZE}
	Set C_OPTIONS "{C_OPTIONS} -opt speed -target 604"
End
If {USE_TRACEBACKS}
	Set C_OPTIONS "{C_OPTIONS} -traceback"
End

Export C_OPTIONS

###=============================================================================

If !`Exists "{TEMP_ROOT}"`
	NewFolder "{TEMP_ROOT}"
End

If !`Exists "{OUTPUT_ROOT}"`
	NewFolder "{OUTPUT_ROOT}"
End

###=============================================================================

{SRC_ROOT}1BuildTVImport.ts
{SRC_ROOT}1BuildTVMedia.ts

###=============================================================================

Set TV_COMPONENTS "{OUTPUT_ROOT}!TV Components"
If `Exists "{TV_COMPONENTS}"`
	Delete -y "{TV_COMPONENTS}"
End

Rez "{SRC_ROOT}2BuildSingleComponent.r" -o "{TV_COMPONENTS}"
Setfile "{TV_COMPONENTS}" -t 'THNG' -c 'RNST'

###=============================================================================
