#define UseExtendedThingResource 1

#include "Types.r"
#include "Components.r"
#include "QuickTimeComponents.r"
#include "TVImportVersion.h"

///==============================================================================

resource 'STR ' (133,""){
 	"Maynard's TV Import Component"
};

resource 'STR ' (233,""){
 	"Converts a TV file into a QuickTime movie."
};
///==============================================================================

#define kImportFlagsForFileType          							\
  canMovieImportFiles| canMovieImportInPlace| canMovieImportPartial	
//    | hasMovieImportMIMEList
#define kImportFlagsForFilenameExtension 							\
  canMovieImportFiles| canMovieImportInPlace| canMovieImportPartial \
//    | hasMovieImportMIMEList										
//    | movieImportSubTypeIsFileExtension


//should add importers for MPEG2 
//for now we can fake by justing using .mpg suffixes !!!

resource 'thng' (1000, "TV Importer") {
	'eat ',
	'mhTV',
	'mhTV',
	0,
	kAnyComponentFlagsMask,
	0,
	0,
	'STR ',
	133,
	'STR ',
	233,
	0,
	0, 

	kTVImportVersion,
	componentHasMultiplePlatforms
	  | componentDoAutoVersion | componentAutoVersionIncludeFlags,	
	0,
	{
		kImportFlagsForFileType,
		'eat ',
		133,
		platformPowerPC
	}
};

#if 0

resource 'thng' (2000, "Real MPEG Importer, 'M1V '") {
	'eat ',
	'M1V ',
	'm1v ',
	0,
	kAnyComponentFlagsMask,
	0,
	0,
	'STR ',
	133,
	'STR ',
	233,
	0,
	0, 

	kMPEGImportVersion,
	componentHasMultiplePlatforms
	  | componentDoAutoVersion | componentAutoVersionIncludeFlags,
	0,
	{
		kImportFlagsForFileType,
		'eat ',
		133,
		platformPowerPC
	}
};

resource 'thng' (3000, "Real MPEG Importer, 'M1A '") {
	'eat ',
	'M1A ',
	'm1a ',
	0,
	kAnyComponentFlagsMask,
	0,
	0,
	'STR ',
	133,
	'STR ',
	233,
	0,
	0, 

	kMPEGImportVersion,
	componentHasMultiplePlatforms
  	  | componentDoAutoVersion | componentAutoVersionIncludeFlags,

	0,
	{
		kImportFlagsForFileType,
		'eat ',
		133,
		platformPowerPC
	}
};


/////////////////////////////////////////

//temp
resource 'thng' (1234, "Real MPEG Importer, 'M2V '") {
	'eat ',
	'M2V ',
	'm2v ',
	0,
	kAnyComponentFlagsMask,
	0,
	0,
	'STR ',
	133,
	'STR ',
	233,
	0,
	0, 

	kMPEGImportVersion,
	componentHasMultiplePlatforms
  	  | componentDoAutoVersion | componentAutoVersionIncludeFlags,

	0,
	{
		kImportFlagsForFilenameExtension,
		'eat ',
		133,
		platformPowerPC
	}
};
//temp
resource 'thng' (1235, "Real MPEG Importer, 'VOB '") {
	'eat ',
	'VOB ',
	'm2v ',
	0,
	kAnyComponentFlagsMask,
	0,
	0,
	'STR ',
	133,
	'STR ',
	233,
	0,
	0, 

	kMPEGImportVersion,
	componentHasMultiplePlatforms
  	  | componentDoAutoVersion | componentAutoVersionIncludeFlags,

	0,
	{
		kImportFlagsForFilenameExtension,
		'eat ',
		133,
		platformPowerPC
	}
};

///------------------------------------------------------------------------------

//We have essentially three sets of importers, those that import a muxed 
//MPEG stream, those that import a video-only stream, and those that import 
//an audio only stream. 
//An importer sets the subtype field to the type (or extension) of the 
//imported file, and the creator field to the type of the track imported into.
//Thus we have the somewhat unfortunate situation that for some of the more 
//ambiguous file types we register three importers, for each of these stream 
//types into which the file might be imported, but what can you do?
//The resourceIDs used to number the components form three series, 
//10xx is for muxed streams, 20xx for video only streams and 30xx for audio streams.
//Within those domains we have varying levels of how common suffixes are.
//First  we deal with the suffixes/types 
//       MPEG and MPG.
//Second the VideoCD suffixes 
//       .dat and .rtf.
//Third  the Sparkle file type ('M1V ') and the Minerva file types, 
//       'M1V ', 'MPGx', 'MPGv', 'MPGa'.
//Fourth the sensible standard suffixes, 
//       .m1s, .m1v, .m1a
//Fifth  the less sensible (but common) internet suffixes,
//       .m75, .m15, .mp2
//Sixth  the less sensible suffixes used by Minerva
//       .mpm, .mpv, .mpa
//
//(Note that in the #defines below
//the type of an MPEG muxed track is 'MPEG' (for historical reasons)
//  while the type of an MPEG video only track is 'm1v ' and likewise 'm1a '.
//Rez is not case-sensitive, so ks_ and kt_ are used as prefixes to 
//  importers that import based on file type (kt_) or file suffix (ks_).

#define kt_MPEG_to_MPEG 1010  //This is used as the canonical MPEG importer.
#define ks_mpeg_to_MPEG 1011
#define kt_MPG_to_MPEG  1012
#define ks_mpg_to_MPEG  1013

#define kt_MPEG_to_m1v  2010
#define ks_mpeg_to_m1v  2011
#define kt_MPG_to_m1v   2012
#define ks_mpg_to_m1v   2013

#define kt_MPEG_to_m1a  3010
#define ks_mpeg_to_m1a  3011
#define kt_MPG_to_m1a   3012
#define ks_mpg_to_m1a   3013


#define ks_dat_to_MPEG	1020
#define ks_rtf_to_MPEG	1021


#define kt_M1V_to_m1v	2030  //This is used as the canonical m1v importer.
#define kt_M1A_to_m1a	2031  //This is used as the canonical m1a importer.

#define kt_MPGx_to_MPEG	1031
#define kt_MPGv_to_m1v	2031
#define kt_MPGa_to_m1a	3031


#define ks_m1s_to_MPEG	1040
#define ks_m1v_to_m1v	2040
#define ks_m1a_to_m1a	3040


#define ks_m75_to_m1v	2050
#define ks_m15_to_m1v	2051
#define ks_mp2_to_m1a	3052


#define ks_mpm_to_MPEG	1060
#define ks_mpv_to_m1v	2060
#define ks_mpa_to_m1a	3060

///==============================================================================

resource 'thga' (ks_mpeg_to_MPEG, "MPEG Importer, 'mpeg'") {
	'eat ',
	'MPEG',
	'MPEG',
	kImportFlagsForFilenameExtension,
	kAnyComponentFlagsMask,
	0,
	0,
	'STR ',
	133,
	'STR ',
	233,
	0,
	0, 

	'eat ',
	'MPEG',
	'MPEG',
	0,
	movieImportSubTypeIsFileExtension
};
resource 'thga' (kt_MPG_to_MPEG, "MPEG Importer, 'MPG '") {
	'eat ',
	'MPG ',
	'MPEG',
	kImportFlagsForFileType,
	kAnyComponentFlagsMask,
	0,
	0,
	'STR ',
	133,
	'STR ',
	233,
	0,
	0, 

	'eat ',
	'MPEG',
	'MPEG',
	0,
	movieImportSubTypeIsFileExtension
};
resource 'thga' (ks_mpg_to_MPEG, "MPEG Importer, .mpg") {
	'eat ',
	'MPG ',
	'MPEG',
	kImportFlagsForFilenameExtension,
	kAnyComponentFlagsMask,
	0,
	0,
	'STR ',
	133,
	'STR ',
	233,
	0,
	0, 

	'eat ',
	'MPEG',
	'MPEG',
	0,
	movieImportSubTypeIsFileExtension
};


resource 'thga' (kt_MPEG_to_M1V, "MPEG Importer, 'MPEG'") {
	'eat ',
	'MPEG',
	'm1v ',
	kImportFlagsForFileType,
	kAnyComponentFlagsMask,
	0,
	0,
	'STR ',
	133,
	'STR ',
	233,
	0,
	0, 

	'eat ',
	'M1V ',
	'm1v ',
	0,
	movieImportSubTypeIsFileExtension
};
resource 'thga' (ks_mpeg_to_M1V, "MPEG Importer, 'mpeg'") {
	'eat ',
	'MPEG',
	'm1v ',
	kImportFlagsForFilenameExtension,
	kAnyComponentFlagsMask,
	0,
	0,
	'STR ',
	133,
	'STR ',
	233,
	0,
	0, 

	'eat ',
	'M1V ',
	'm1v ',
	0,
	movieImportSubTypeIsFileExtension
};
resource 'thga' (kt_MPG_to_M1V, "MPEG Importer, 'MPG '") {
	'eat ',
	'MPG ',
	'm1v ',
	kImportFlagsForFileType,
	kAnyComponentFlagsMask,
	0,
	0,
	'STR ',
	133,
	'STR ',
	233,
	0,
	0, 

	'eat ',
	'M1V ',
	'm1v ',
	0,
	movieImportSubTypeIsFileExtension
};
resource 'thga' (ks_mpg_to_M1V, "MPEG Importer, .mpg") {
	'eat ',
	'MPG ',
	'm1v ',
	kImportFlagsForFilenameExtension,
	kAnyComponentFlagsMask,
	0,
	0,
	'STR ',
	133,
	'STR ',
	233,
	0,
	0, 

	'eat ',
	'M1V ',
	'm1v ',
	0,
	movieImportSubTypeIsFileExtension
};

resource 'thga' (kt_MPEG_to_M1A, "MPEG Importer, 'MPEG'") {
	'eat ',
	'MPEG',
	'm1a ',
	kImportFlagsForFileType,
	kAnyComponentFlagsMask,
	0,
	0,
	'STR ',
	133,
	'STR ',
	233,
	0,
	0, 

	'eat ',
	'M1A ',
	'm1a ',
	0,
	movieImportSubTypeIsFileExtension
};
resource 'thga' (ks_mpeg_to_M1A, "MPEG Importer, 'mpeg'") {
	'eat ',
	'MPEG',
	'm1a ',
	kImportFlagsForFilenameExtension,
	kAnyComponentFlagsMask,
	0,
	0,
	'STR ',
	133,
	'STR ',
	233,
	0,
	0, 

	'eat ',
	'M1A ',
	'm1a ',
	0,
	movieImportSubTypeIsFileExtension
};
resource 'thga' (kt_MPG_to_M1A, "MPEG Importer, 'MPG '") {
	'eat ',
	'MPG ',
	'm1a ',
	kImportFlagsForFileType,
	kAnyComponentFlagsMask,
	0,
	0,
	'STR ',
	133,
	'STR ',
	233,
	0,
	0, 

	'eat ',
	'M1A ',
	'm1a ',
	0,
	movieImportSubTypeIsFileExtension
};
resource 'thga' (ks_mpg_to_M1A, "MPEG Importer, .mpg") {
	'eat ',
	'MPG ',
	'm1a ',
	kImportFlagsForFilenameExtension,
	kAnyComponentFlagsMask,
	0,
	0,
	'STR ',
	133,
	'STR ',
	233,
	0,
	0, 

	'eat ',
	'M1A ',
	'm1a ',
	0,
	movieImportSubTypeIsFileExtension
};
///-----------------------------------------------------------------------------

resource 'thga' (ks_dat_to_MPEG, "MPEG Importer, .dat") {
	'eat ',
	'DAT ',
	'MPEG',
	kImportFlagsForFilenameExtension,
	kAnyComponentFlagsMask,
	0,
	0,
	'STR ',
	133,
	'STR ',
	233,
	0,
	0, 

	'eat ',
	'MPEG',
	'MPEG',
	0,
	movieImportSubTypeIsFileExtension
};
resource 'thga' (ks_rtf_to_MPEG, "MPEG Importer, .rtf") {
	'eat ',
	'RTF ',
	'MPEG',
	kImportFlagsForFilenameExtension,
	kAnyComponentFlagsMask,
	0,
	0,
	'STR ',
	133,
	'STR ',
	233,
	0,
	0, 

	'eat ',
	'MPEG',
	'MPEG',
	0,
	movieImportSubTypeIsFileExtension
};
///-----------------------------------------------------------------------------

resource 'thga' (kt_MPGx_to_MPEG, "MPEG Importer, 'MPGx'") {
	'eat ',
	'MPGx',
	'MPEG',
	kImportFlagsForFileType,
	kAnyComponentFlagsMask,
	0,
	0,
	'STR ',
	133,
	'STR ',
	233,
	0,
	0, 

	'eat ',
	'MPEG',
	'MPEG',
	0,
	movieImportSubTypeIsFileExtension
};
resource 'thga' (kt_MPGv_to_m1v, "MPEG Importer, 'MPGv '") {
	'eat ',
	'MPGv',
	'm1v ',
	kImportFlagsForFileType,
	kAnyComponentFlagsMask,
	0,
	0,
	'STR ',
	133,
	'STR ',
	233,
	0,
	0, 

	'eat ',
	'M1V ',
	'm1v ',
	0,
	movieImportSubTypeIsFileExtension
};
resource 'thga' (kt_MPGa_to_m1a, "MPEG Importer, 'MPGa '") {
	'eat ',
	'MPGa',
	'm1a ',
	kImportFlagsForFileType,
	kAnyComponentFlagsMask,
	0,
	0,
	'STR ',
	133,
	'STR ',
	233,
	0,
	0, 

	'eat ',
	'M1A ',
	'm1a ',
	0,
	movieImportSubTypeIsFileExtension
};
///-----------------------------------------------------------------------------

resource 'thga' (ks_m1s_to_MPEG, "MPEG Importer, .m1s") {
	'eat ',
	'M1S ',
	'MPEG',
	kImportFlagsForFilenameExtension,
	kAnyComponentFlagsMask,
	0,
	0,
	'STR ',
	133,
	'STR ',
	233,
	0,
	0, 

	'eat ',
	'MPEG',
	'MPEG',
	0,
	movieImportSubTypeIsFileExtension
};

resource 'thga' (ks_m1v_to_m1v, "MPEG Importer, .m1v") {
	'eat ',
	'M1V ',
	'm1v ',
	kImportFlagsForFilenameExtension,
	kAnyComponentFlagsMask,
	0,
	0,
	'STR ',
	133,
	'STR ',
	233,
	0,
	0, 

	'eat ',
	'M1V ',
	'm1v ',
	0,
	movieImportSubTypeIsFileExtension
};

resource 'thga' (ks_m1a_to_m1a, "MPEG Importer, .m1a") {
	'eat ',
	'M1A ',
	'm1a ',
	kImportFlagsForFilenameExtension,
	kAnyComponentFlagsMask,
	0,
	0,
	'STR ',
	133,
	'STR ',
	233,
	0,
	0, 

	'eat ',
	'M1A ',
	'm1a ',
	0,
	movieImportSubTypeIsFileExtension
};
///-----------------------------------------------------------------------------

resource 'thga' (ks_m75_to_m1v, "MPEG Importer, .m75") {
	'eat ',
	'M75 ',
	'm1v ',
	kImportFlagsForFilenameExtension,
	kAnyComponentFlagsMask,
	0,
	0,
	'STR ',
	133,
	'STR ',
	233,
	0,
	0, 

	'eat ',
	'M1V ',
	'm1v ',
	0,
	movieImportSubTypeIsFileExtension
};
resource 'thga' (ks_m15_to_m1v, "MPEG Importer, .m15") {
	'eat ',
	'M15 ',
	'm1v ',
	kImportFlagsForFilenameExtension,
	kAnyComponentFlagsMask,
	0,
	0,
	'STR ',
	133,
	'STR ',
	233,
	0,
	0, 

	'eat ',
	'M1V ',
	'm1v ',
	0,
	movieImportSubTypeIsFileExtension
};

resource 'thga' (ks_mp2_to_m1a, "MPEG Importer, .mp2") {
	'eat ',
	'MP2 ',
	'm1a ',
	kImportFlagsForFilenameExtension,
	kAnyComponentFlagsMask,
	0,
	0,
	'STR ',
	133,
	'STR ',
	233,
	0,
	0, 

	'eat ',
	'M1A ',
	'm1a ',
	0,
	movieImportSubTypeIsFileExtension
};
///-----------------------------------------------------------------------------

resource 'thga' (ks_mpm_to_MPEG, "MPEG Importer, .mpm") {
	'eat ',
	'MPM ',
	'MPEG',
	kImportFlagsForFilenameExtension,
	kAnyComponentFlagsMask,
	0,
	0,
	'STR ',
	133,
	'STR ',
	233,
	0,
	0, 

	'eat ',
	'MPEG',
	'MPEG',
	0,
	movieImportSubTypeIsFileExtension
};
resource 'thga' (ks_mpv_to_m1v, "MPEG Importer, .mpv") {
	'eat ',
	'MPV ',
	'm1v ',
	kImportFlagsForFilenameExtension,
	kAnyComponentFlagsMask,
	0,
	0,
	'STR ',
	133,
	'STR ',
	233,
	0,
	0, 

	'eat ',
	'M1V ',
	'm1v ',
	0,
	movieImportSubTypeIsFileExtension
};

resource 'thga' (ks_mpa_to_m1a, "MPEG Importer, .mpa") {
	'eat ',
	'MPA ',
	'm1a ',
	kImportFlagsForFilenameExtension,
	kAnyComponentFlagsMask,
	0,
	0,
	'STR ',
	133,
	'STR ',
	233,
	0,
	0, 

	'eat ',
	'M1A ',
	'm1a ',
	0,
	movieImportSubTypeIsFileExtension
};
///==============================================================================

//Need to get correct values for MPEG2 here!!!
resource 'mime' (kEatMPEGMimeResID) {
	{
	kMimeInfoMimeTypeTag, 		1, "video/mpeg";
	kMimeInfoMimeTypeTag, 		2, "video/x-mpeg";
	kMimeInfoMimeTypeTag, 		3, "audio/mpeg";
	kMimeInfoMimeTypeTag, 		4, "audio/x-mpeg";
	kMimeInfoMimeTypeTag, 		5, "video/mpeg2";
	kMimeInfoFileExtensionTag,	1, "mpeg,mpg,m1s,m1v,m1a,m75,m15,mp2,mpm,mpv,mpa";
	kMimeInfoFileExtensionTag,	2, "mpeg,mpg,m1s,m1v,m1a,m75,m15,mp2,mpm,mpv,mpa";
	kMimeInfoFileExtensionTag,	3, "mpeg,mpg,m1s,m1a,mp2,mpm,mpa";
	kMimeInfoFileExtensionTag,	4, "mpeg,mpg,m1s,m1a,mp2,mpm,mpa";
	kMimeInfoFileExtensionTag,	5, "m2v,vob";
	kMimeInfoDescriptionTag,	1, "MPEG video/audio stream";
	kMimeInfoDescriptionTag,	2, "MPEG video/audio stream";
	kMimeInfoDescriptionTag,	3, "MPEG audio stream";
	kMimeInfoDescriptionTag,	4, "MPEG audio stream";
	kMimeInfoDescriptionTag,	5, "MPEG2 video/audio stream";
	}
};
///==============================================================================
#endif 