#ifndef TVMediaHandler_H
#define TVMediaHandler_H

#include "Maynard.h"
#include <QuickTimeComponents.h>
#include <MediaHandlers.h>

///=============================================================================

struct TVMediaHandlerRecord{
	ComponentInstance		self;
	ComponentInstance		parent;
	ComponentInstance		delegateComponent;
	struct TVMediaHandlerGlobals* globalsAlias;
	
	Movie				    movie;
	Track				    track;
	Media				    media;
	Handle 					sampleDescriptionH;

	BOOL1(					fEnabled);

	BOOL1(                  fHasEyes);
	BOOL1(                  fHasEars);

	//Variables related to the time structure of this track.
	TimeScale				movieTimeScale;
	TimeScale				mediaTimeScale;
	TimeValue 				trackEndTime_movieAxis;
	TimeValue 				mediaEndTime_mediaAxis;
	TimeBase				movieTimeBase;

	//Variables related to audio properties.
	short					volume;	
	short					balance;
	Component 				soundOutputComponent;

	//Variables related to video properties.
	//NOTE: The MPEG media handler owns this clipRegionH and is responsible 
	// for disposing of it, not the lower level components.
	Fixed        			fxWidth, fxHeight;
	MatrixRecord 			trackMovieMatrix;
	CGrafPtr     			cgrafPtr;
	GDHandle      			gdeviceH;
	long 					graphicsMode;
	RGBColor 				opColor;
	RgnHandle				clipRgnH;
	Fixed		  			fxEffectiveClockRate;


	//Vars for controlling the sequenceGrabber and thus our display.
	ComponentInstance sequenceGrabber;
	SGChannel         sequenceGrabberVideoChannel;
	BOOL              fSGActive;
BOOL fStartedPreview;
};
typedef struct TVMediaHandlerRecord TVMediaHandlerRecord;

///-----------------------------------------------------------------------------

struct TVMediaHandlerGlobals{
	UINT8 junk;
};
typedef struct TVMediaHandlerGlobals TVMediaHandlerGlobals;

///=============================================================================

//Open, close and initialization functions.

OSErr TVMediaNewInstance(
  ComponentInstance self, TVMediaHandlerGlobals* globalsPtr);
OSErr TVMediaNewSharedGlobalsIfNecessary(
  Component self, TVMediaHandlerGlobals** globalsPtrPtr);

void TVMediaDisposeInstance(
  TVMediaHandlerRecord* thiss, ComponentInstance self);
void TVMediaDisposeSharedGlobalsIfNecessary(
  Component self, TVMediaHandlerGlobals* globalsPtr);

OSErr TVMediaInitializeInstance(
  TVMediaHandlerRecord* thiss, GetMovieCompleteParams const* gmcPtr);
OSErr TVMediaInitializeSharedGlobalsIfNecessary(
  Component self, TVMediaHandlerGlobals* globalsPtr);

///-----------------------------------------------------------------------------

OSErr TestIfHasEarsOrEyesCharacteristicsAndInformBaseMediaHandler(
  TVMediaHandlerRecord* thiss);
///=============================================================================

#endif //TVMediaHandler_H
